local transtonum = {
	[FF_TRANS90] = 9,
	[FF_TRANS80] = 8,
	[FF_TRANS70] = 7,
	[FF_TRANS60] = 6,
	[FF_TRANS50] = 5,
	[FF_TRANS40] = 4,
	[FF_TRANS30] = 3,
	[FF_TRANS20] = 2,
	[FF_TRANS10] = 1,
	[0] = 0
}
local numtotrans = {
	[9] = FF_TRANS90,
	[8] = FF_TRANS80,
	[7] = FF_TRANS70,
	[6] = FF_TRANS60,
	[5] = FF_TRANS50,
	[4] = FF_TRANS40,
	[3] = FF_TRANS30,
	[2] = FF_TRANS20,
	[1] = FF_TRANS10,
	[0] = 0,
}
local TR = TICRATE

freeslot("SKINCOLOR_TOPAZ")
freeslot("SKINCOLOR_MOONSTONE")
skincolors[SKINCOLOR_TOPAZ] = {
	name = "Topaz",
	ramp = {0,81,83,73,74,74,65,52,53,54,56,58,60,42,43,45},
	invcolor = SKINCOLOR_MOONSTONE,
    invshade = 10,
    chatcolor = V_YELLOWMAP,
    accessible = true
}
skincolors[SKINCOLOR_MOONSTONE] = {
	name = "Moonstone",
	ramp = {0,4,8,9,11,12,14,15,171,172,173,174,175,27,29,31},
	invcolor = SKINCOLOR_TOPAZ,
    invshade = 15,
    chatcolor = V_GRAYMAP,
    accessible = true
}
freeslot("SKINCOLOR_SIBERITE")
skincolors[SKINCOLOR_SIBERITE] = {
	name = "Siberite",
	ramp = {252,177,179,180,181,181,182,182,183,164,166,167,167,168,169,159},
	invcolor = SKINCOLOR_EMERALD,
    invshade = 8,
    chatcolor = V_MAGENTAMAP,
    accessible = true
}
freeslot("SKINCOLOR_SKY")
freeslot("SKINCOLOR_SANDY")
skincolors[SKINCOLOR_SKY] = {
	name = "Sky",
	ramp = {128,128,129,130,131,131,132,133,133,134,135,136,137,137,138,139},
	invcolor = SKINCOLOR_SANDY,
    invshade = 1,
    chatcolor = V_SKYMAP,
    accessible = true
}
skincolors[SKINCOLOR_SANDY] = {
	name = "Sandy",
	ramp = {83,64,65,66,67,230,233,233,234,236,236,198,198,199,199,254},
	invcolor = SKINCOLOR_SKY,
    invshade = 8,
    chatcolor = V_YELLOWMAP,
    accessible = true
}
/*(
M_MoveColorAfter(SKINCOLOR_TOPAZ,SKINCOLOR_TANGERINE)
M_MoveColorAfter(SKINCOLOR_SANDY,SKINCOLOR_GOLD)
M_MoveColorAfter(SKINCOLOR_MOONSTONE,SKINCOLOR_SLATE)
M_MoveColorAfter(SKINCOLOR_SIBERITE,SKINCOLOR_FUCHSIA)
M_MoveColorAfter(SKINCOLOR_SKY,SKINCOLOR_AQUAMARINE)
*/

freeslot("sfx_sptclt")
freeslot("SPR_MDST")
freeslot("MT_TAKIS_STEAM")
freeslot("S_TAKIS_STEAM")
freeslot("S_TAKIS_STEAM2")
states[S_TAKIS_STEAM] = {
	sprite = SPR_MDST,
	frame = A|FF_ANIMATE,
	var1 = 3,
	var2 = 1,
	tics = 3*1,
	nextstate = S_TAKIS_STEAM2,
}
states[S_TAKIS_STEAM2] = {
	sprite = SPR_MDST,
	frame = D|FF_ANIMATE,
	var1 = 7,
	var2 = 1,
	tics = 1*7,
	nextstate = S_TAKIS_STEAM2
}

mobjinfo[MT_TAKIS_STEAM] = {
	doomednum = -1,
	spawnstate = S_TAKIS_STEAM,
	spawnhealth = 1,
	height = 6*FRACUNIT,
	radius = 6*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_SCENERY|MF_NOCLIP|MF_NOGRAVITY|MF_NOCLIPHEIGHT
}

freeslot("MT_TAKIS_AFTERIMAGE")
freeslot("S_TAKIS_AFTERIMAGE")
states[S_TAKIS_AFTERIMAGE] = {
	sprite = SPR_PLAY,
	frame = A,
	tics = -1,
	nextstate = S_TAKIS_AFTERIMAGE
}
mobjinfo[MT_TAKIS_AFTERIMAGE] = {
	doomednum = -1,
	spawnstate = S_TAKIS_AFTERIMAGE,
	radius = 12*FRACUNIT,
	height = 10*FRACUNIT,
	flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY|MF_NOBLOCKMAP	
}

freeslot("SPR_TGIB")
freeslot("S_TAKIS_GIB")
freeslot("MT_TAKIS_GIB")
states[S_TAKIS_GIB] = {
	sprite = SPR_TGIB,
	frame = A,
	tics = -1,
}
mobjinfo[MT_TAKIS_GIB] = {
	doomednum = -1,
	spawnstate = S_TAKIS_GIB,
	flags = MF_SLIDEME|MF_NOCLIPTHING|MF_NOSQUISH,
	height = 4*FRACUNIT,
	radius = 4*FRACUNIT,
}

rawset(_G, 'L_ZLaunch', function(mo,thrust,relative)
	if mo.eflags&MFE_UNDERWATER
		thrust = $*3/5
	end
	P_SetObjectMomZ(mo,thrust,relative)
end)

rawset(_G,"TakisSpawnDust",function(me,angle,dist,z,options)
	if options == nil then
		options = {
			xspread = (P_RandomFixed()*((P_RandomChance(FU/2)) and 1 or -1)),
			yspread = (P_RandomFixed()*((P_RandomChance(FU/2)) and 1 or -1)),
			zspread = (P_RandomFixed()*((P_RandomChance(FU/2)) and 1 or -1)),
			
			thrust = 0,
			thrustspread = 0,
			
			momz = P_RandomRange(6,1)*me.scale,
			momzspread = (P_RandomFixed()*((P_RandomChance(FU/2)) and 1 or -1)),
			
			scale = me.scale,
			scalespread = (P_RandomFixed()/2*((P_RandomChance(FU/2)) and 1 or -1)),
			
			fuse = 20,
		}
	end
	
	local x,y = cos(angle),sin(angle)
	local steam = P_SpawnMobjFromMobj(me,
		dist*x+options.xspread,
		dist*y+options.yspread,
		z+options.zspread,
		MT_TAKIS_STEAM
	)
	steam.angle = angle
	P_Thrust(steam,steam.angle,options.thrust+options.thrustspread)
	L_ZLaunch(steam,
		options.momz+options.momzspread,
		false
	)
	steam.scale = options.scale+options.scalespread
	steam.timealive = 1
	steam.tracer = me
	steam.destscale = 1
	steam.fuse = options.fuse
	steam.startfuse = steam.fuse
	steam.rollangle = $+(ANGLE_180*(P_RandomChance(FU/2) and 1 or 0))
	return steam
end)

rawset(_G, "TakisCreateAfterimage", function(p,me)
	if not me
	or not me.valid
		return
	end
	
	local takis = p.takistable
	
	local ghost = P_SpawnMobjFromMobj(me,0,0,0,MT_TAKIS_AFTERIMAGE)
	ghost.target = me
	
	ghost.skin = me.skin
	ghost.scale = me.scale
	
	ghost.sprite = me.sprite
	
	ghost.state = me.state
	ghost.sprite2 = me.sprite2
	ghost.takis_frame = me.frame
	ghost.tics = -1
	ghost.colorized = true
	
	ghost.angle = p.drawangle
	
	local color = SKINCOLOR_GREEN
	
	--not everyone is salmon
	local salnum = #skincolors[ColorOpposite(p.skincolor)]
	takis.afterimagecolor = $+1
	if (takis.afterimagecolor > #skincolors-1-salnum)
		takis.afterimagecolor = 1
	end
	color = salnum+takis.afterimagecolor
	
	--STILL over the max colors??
	if color > #skincolors-1
		--whatever....
		salnum = #skincolors[ColorOpposite(SKINCOLOR_PINETREE)]
		color = salnum+takis.afterimagecolor
	end
	if p.invincibilitytimer
		local pw_inv = p.invincibilitytimer
		local defaultTime = (8*TICRATE)+(2*TICRATE)
		local flicker = 2
		
		if pw_inv > defaultTime
			color = me.color
		else
			flicker = $+(defaultTime-pw_inv)/TICRATE/2
		end
		
		if not (leveltime % flicker == 0)
			color = salnum+takis.afterimagecolor
		end
	end
	
	--theres blendmods but THEYRE BARELY VISIBLE so whats the point
	--ghost.renderflags = $|RF_ADD
	
	ghost.color = color
	ghost.takis_spritexscale,ghost.takis_spriteyscale = me.spritexscale, me.spriteyscale
	ghost.takis_spritexoffset,ghost.takis_spriteyoffset = me.spritexoffset, me.spriteyoffset
	ghost.takis_rollangle = me.rollangle
	
	return ghost
end)

local function choosething(...)
	local args = {...}
	local choice = P_RandomRange(1,#args)
	return args[choice]
end

rawset(_G,"MetalOrRegularGibs",function(mo)
	local spawnmetal = true
	
	if ((mo.flags & MF_ENEMY|MF_BOSS)
	or (mo.type == MT_TAKIS_BADNIK_RAGDOLL))
		if mo.takis_metalgibs ~= nil
			spawnmetal = mo.takis_metalgibs
		end
	end
	
	if (mo.type == MT_PLAYER or mo.sprite == SPR_PLAY)
		if not (
			(mo.player and (mo.player.charflags & SF_MACHINE))
			or
			(skins[mo.skin].flags & SF_MACHINE)
		)
			spawnmetal = false
		else
			spawnmetal = true
		end
	end
	
	return spawnmetal
end)

rawset(_G,"SpawnEnemyGibs",function(t,tm,ang)
	local count = P_RandomRange(9,19)
	
	local mo = tm or t
	for i = 0,count
		
		local fa = FixedAngle(i*FixedDiv(360*FU,count*FU))
		local radius = 15*mo.scale
		local v = {}
		v[0] = FixedMul(cos(fa),radius)
		v[1] = FixedMul(sin(fa),radius)
		v[2] = 0
		v[3] = FU
		
		local final = {
			x = mo.x+v[0],
			y = mo.y+v[1],
			z = mo.z+v[2]+(mo.height/2),
		}
		local x,y,z = final.x,final.y,final.z
	
		local gib = P_SpawnMobj(x,y,z,MT_TAKIS_GIB)
		gib.scale = mo.scale
		gib.iwillbouncetwice = P_RandomChance(FU/2)
		
		gib.frame = P_RandomRange(A,I)
		if (mo and mo.valid)
			if not fromdoor
				if not MetalOrRegularGibs(mo)
					gib.frame = choosething(A,B,E,G,H,I)
				end
			else
				gib.frame = A
				gib.sprite = states[S_WOODDEBRIS].sprite
				gib.radius = 10*gib.scale
				gib.height = 10*gib.scale
			end
		end
		gib.flags2 = $|(mo.flags2 & MF2_OBJECTFLIP)
		
		local angrng = P_RandomRange(0,1)
		gib.angle = fa
		gib.rollangle = FixedAngle(P_RandomRange(0,359)*FU+P_RandomFixed())
		gib.angleroll = FixedAngle(P_RandomRange(1,15)*FU+P_RandomFixed())*(angrng or -1)
		gib.fuse = 3*TR
		L_ZLaunch(gib,P_RandomRange(4,15)*FU+P_RandomFixed())
		/*
		if (t and t.valid)
			P_Thrust(gib,
				R_PointToAngle2(t.x,t.y, tm.x,tm.y),
				speed/6
			)
		end
		*/
		P_Thrust(gib,gib.angle,P_RandomRange(1,10)*gib.scale+P_RandomFixed())
	end
end)

local function getmaxspeed()
	--gear 1
	if gamespeed == 0
		return 45*FU
	--gear 2
	elseif gamespeed == 1
		return 50*FU
	--gear 3
	elseif gamespeed == 2
		return 60*FU
	--no 4th gear
	end
end

addHook("PlayerThink",function(p)
	local me = p.mo
	if not (me and me.valid) then return end
	
	if p.takistable == nil
		p.takistable = {
			afterimagecolor = 1,
			accspeed = 0,
			gibtime = 0,
		}
	end
	local takis = p.takistable
	takis.accspeed = FixedDiv(abs(FixedHypot(p.rmomx,p.rmomy)), me.scale)
	
	if takis.gibtime
		SpawnEnemyGibs(me,me)
		takis.gibtime = $-1
	end
	
	if (me.skin ~= "takisthefox") then return end
	
	if takis.accspeed >= 45*FU
	or (p.exiting)
	or (p.invincibilitytimer)
		TakisCreateAfterimage(p,me)
	else
		takis.afterimagecolor = 1
	end
	
end)

addHook("MobjThinker",function(mo)
	if not mo
	or not mo.valid
		return
	end
	
	mo.startfuse = $ or 20
	mo.timealive = $+1
	if (mo.startfuse - mo.timealive) <= 10
		if mo.scalespeed == 0
			mo.scalespeed = FU/20
		end
		mo.scalespeed = $*6/5
	else
		mo.scalespeed = 0
	end
	
	local mul = FU*19/22	
	mo.momx,mo.momy,mo.momz = FixedMul($1,mul),FixedMul($2,mul),FixedMul($3,mul)
end,MT_TAKIS_STEAM)

addHook("MobjThinker", function(ai)
	if not ai
	or not ai.valid
		return
	end
	
	--we need a thing to follow
	if not ai.target
	or not ai.target.valid
		P_RemoveMobj(ai)
		return
	end
	
	local p = ai.target.player
	local me = p.mo
	
	--bruh
	if not me
	or not me.valid
		P_RemoveMobj(ai)
		return
	end
	
	ai.colorized = true
	if not ai.timealive
		ai.timealive = 1	
	else
		ai.timealive = $+1
	end
	
	ai.spritexoffset = ai.takis_spritexoffset or 0
	ai.spriteyoffset = ai.takis_spriteyoffset or 0
	ai.spritexscale = ai.takis_spritexscale or FU
	ai.spriteyscale = ai.takis_spriteyscale or FU
	ai.rollangle = ai.takis_rollangle or 0
	
	local transnum = numtotrans[((ai.timealive*2/3)+1) %9]
	ai.frame = ai.takis_frame|transnum
	local fuselimit = 5
	
	--because fuse doesnt wanna work
	if ai.timealive > fuselimit
		P_RemoveMobj(ai)
		return
	end
	
end, MT_TAKIS_AFTERIMAGE)

addHook("MobjThinker",function(gib)
	if not (gib and gib.valid) then return end
	local grav = P_GetMobjGravity(gib)
	grav = $*3/5
	gib.spritexscale,gib.spriteyscale = FU,FU
	gib.momz = $+(grav*P_MobjFlip(gib))
	gib.rollangle = $+(gib.angleroll or 0)
	gib.speed = FixedHypot(gib.momx,gib.momy)
	if (P_IsObjectOnGround(gib)
	and not gib.bounced)
		if not gib.iwillbouncetwice
			gib.flags = $|MF_NOCLIPHEIGHT|MF_NOCLIP
			gib.bounced = true
			gib.tics = 3*TR
			L_ZLaunch(gib,
				(gib.lessbounce and P_RandomRange(2,4) or P_RandomRange(4,9))
				*FU+P_RandomFixed()
			)
		else
			gib.iwillbouncetwice = nil
			gib.lessbounce = true
			L_ZLaunch(gib,P_RandomRange(6,9)*FU+P_RandomFixed())
		end
	end
end,MT_TAKIS_GIB)

addHook("MobjMoveBlocked",function(gib)
	if gib.flags & MF_NOCLIP then return end
	if gib.bounced then return end
	P_BounceMove(gib)
	gib.angle = FixedAngle(AngleFixed($)+180*FU)
end,MT_TAKIS_GIB)

local function hitbytakis(mo,inf,sor)
	if not ((mo.skin == "takisthefox")
	or ((sor and sor.valid) and sor.skin == "takisthefox"))
		return
	end
	
	mo.player.takistable.gibtime = 7
end
addHook("MobjDamage",hitbytakis,MT_PLAYER)
addHook("MobjDeath",hitbytakis,MT_PLAYER)

freeslot(
	"SPR_TDDE",
	"SPR_TDDA",
	"SPR_TDDC",
	"SPR_TDDG",
	"SPR_TDDB",
	"SPR_TDDI",
	"SPR_TDDJ",
	"SPR_TDDK",
	"SPR_TDDH",
	"SPR_TDDF"
)
addHook("MobjThinker",function(car)
	if not (car and car.valid) then return end
	
	local tar = car.target
	if not (tar and tar.valid) then return end
	
	if tar.skin == "takisthefox"
		car.sprite = SPR_TDDF
	end
end,MT_KART_LEFTOVER)

local spritetotakis = {
	[SPR_DIEE] = SPR_TDDE,	--wheel
	[SPR_DIEA] = SPR_TDDA,	--tire
	[SPR_DIEC] = SPR_TDDC,	--pedal bar
	[SPR_DIEG] = SPR_TDDG,	--pedal joint L
	[SPR_DIED] = SPR_TDDG,	--pedal joint R
	[SPR_DIEB] = SPR_TDDB,	--pipeframe
	[SPR_DIEI] = SPR_TDDI,	--various
	[SPR_DIEJ] = SPR_TDDJ,	--various
	[SPR_DIEK] = SPR_TDDK,	--various
	[SPR_DIEH] = SPR_TDDH,	--various
}

addHook("MobjThinker",function(car)
	if not (car and car.valid) then return end
	
	if spritetotakis[car.sprite] == nil
		return
	end
	
	if not car.setgibs
		for p in players.iterate
			local me = p.mo
			
			if not (me and me.valid)
			or (p.spectator)
			or (me.skin ~= "takisthefox")
			or (me.health)
				continue
			end
			
			local hdist = R_PointToDist2(car.x,car.y,me.x,me.y)
			local dist = R_PointToDist2(0,car.z,hdist,me.z)
			
			if dist > 25*FU
				continue
			end
			
			car.sprite = spritetotakis[car.sprite]
			car.setgibs = true
		end
	end
	car.setgibs = true
end,MT_KART_PARTICLE)